// Unlock.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "cpwide.h"
#include "mainfrm.h"
#include "Unlock.h"
#include "amzi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnlock dialog


CUnlock::CUnlock(CWnd* pParent /*=NULL*/)
   : CDialog(CUnlock::IDD, pParent)
{
   //{{AFX_DATA_INIT(CUnlock)
   m_username = _T("");
   m_organization = _T("");
   m_serialno = _T("");
   m_unlockcode = _T("");
   //}}AFX_DATA_INIT

   m_bWaiting = FALSE;
}

void CUnlock::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CUnlock)
   DDX_Text(pDX, IDC_USERNAME, m_username);
   DDV_MaxChars(pDX, m_username, 30);
   DDX_Text(pDX, IDC_ORGANIZATION, m_organization);
   DDV_MaxChars(pDX, m_organization, 30);
   DDX_Text(pDX, IDC_SERIALNO, m_serialno);
   DDV_MaxChars(pDX, m_serialno, 23);
   DDX_Text(pDX, IDC_UNLOCKCODE, m_unlockcode);
   DDV_MaxChars(pDX, m_unlockcode, 19);
   //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnlock, CDialog)
   //{{AFX_MSG_MAP(CUnlock)
   ON_WM_SETCURSOR()
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnlock message handlers

BOOL CUnlock::OnInitDialog() 
{
   m_username = theApp.GetProfileString(_T("Registration"), _T("UserName"));
   m_organization = theApp.GetProfileString(_T("Registration"), _T("Organization"));
   m_serialno = theApp.GetProfileString(_T("Registration"), _T("SerialNo"));
   m_unlockcode = theApp.GetProfileString(_T("Registration"), _T("UnlockCode"));

   CDialog::OnInitDialog();
   
   return TRUE;  // return TRUE unless you set the focus to a control
                 // EXCEPTION: OCX Property Pages should return FALSE
}

// Button is labeled 'Unlock'
void CUnlock::OnOK()
{
   UpdateData();

   theApp.WriteProfileString(_T("Registration"), _T("UserName"), m_username);
   theApp.WriteProfileString(_T("Registration"), _T("Organization"), m_organization);
   theApp.WriteProfileString(_T("Registration"), _T("SerialNo"), m_serialno);
   theApp.WriteProfileString(_T("Registration"), _T("UnlockCode"), m_unlockcode);

   CLogicServer ls;
   _TCHAR *buf = new _TCHAR[513];
   _TCHAR ver[5];
   TERM t;
   TF tf;

   //theApp.m_pMFW->WaitingOn();
   BeginWaitCursor();
   m_bWaiting = TRUE;

   try{

   // unl$lock (which calls unl$rid) can be called on any file
   // that has register.pro linked into it. So we load alis.xpl
   // and use its register code to unlock all 3 xpl files.

   ls.Init(_T(""));
   ls.Load(_T("alis.xpl"));

   // Ensure it is the correct version number
   _stprintf(buf, _T("unl$pid($%s$, _,_, Ver, _,_)"), m_serialno);
   tf = ls.ExecStr(&t, buf);
   if (tf == FALSE)
      goto done;
   ls.GetArg(t, 4, cSTR, &ver);
   if (ver[0] != '4' || ver[2] != '1')    // 4.1 Change when versions change
   {
      tf = FALSE;
      goto done;
   }

   _stprintf(buf, _T("un$lock($%s$, $%s$, $%s$, $%s$, $%s$)"),
         _T("alis.xpl"),
         m_username, m_organization, m_serialno, m_unlockcode);
   ls.ExecStr(&t, _T("set_mode(string_esc, off)"));
   tf = ls.ExecStr(&t, buf);
   if (tf == FALSE)
      goto done;
//   AfxMessageBox(_T("alis.xpl OK"));

   _stprintf(buf, _T("un$lock($%s$, $%s$, $%s$, $%s$, $%s$)"),
         _T("aidl.xpl"),
         m_username, m_organization, m_serialno, m_unlockcode);
   tf = ls.ExecStr(&t, buf);
   if (tf == FALSE)
      goto done;
//   AfxMessageBox(_T("aidl.xpl OK"));

   _stprintf(buf, _T("un$lock($%s$, $%s$, $%s$, $%s$, $%s$)"),
         _T("acmp.xpl"),
         m_username, m_organization, m_serialno, m_unlockcode);
   tf = ls.ExecStr(&t, buf);
   ls.Close();
//   if (tf == TRUE) AfxMessageBox(_T("acmp.xpl OK"));

done:
   if (tf == TRUE)
   {
      theApp.m_pMFW->m_bUnlocked = TRUE;
      AfxMessageBox(_T("Successfully Unlocked"));
   }
   else
   {
      theApp.m_pMFW->m_bUnlocked = FALSE;
      AfxMessageBox(_T("Unlock Unsuccessful\n")
            _T("Make sure your NAME and ORGANIZATION\n")
            _T("are entered exactly as they appear on the\n")
            _T("registration form, and that the SERIAL# and\n")
            _T("UNLOCK CODE are entered, with dashes, exactly\n")
            _T("as they appear as well.  Contact Amzi! if you\n")
            _T("still have problems unlocking the software.") );
   }

   } catch(CLSException &E)
   {
      theApp.m_pMFW->WaitingOff();
      int rc = E.GetRC();
      //CAmziExcept *ae = new CAmziExcept;
      //ae->SetException(E);
      AfxMessageBox(_T("Error during Unlock, notify Amzi! tech support"));
   }

   //theApp.m_pMFW->WaitingOff();
   m_bWaiting = FALSE;
   EndWaitCursor();
   delete[] buf;

   //if (tf == TRUE)
   //   CDialog::OnOK();
   DestroyWindow();
}


BOOL CUnlock::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
   if (m_bWaiting)
   {
      RestoreWaitCursor();
      return TRUE;
   }
   else
      return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

void CUnlock::OnCancel() 
{
   DestroyWindow();
}

void CUnlock::PostNcDestroy() 
{
   // TODO: Add your specialized code here and/or call the base class
   
   CDialog::PostNcDestroy();
   delete this;
}
